package web

import (
  "github.com/flamego/binding"
  "github.com/flamego/flamego"

  "git.metaunix.net/bitgoblin/blt/web/forms"
  "git.metaunix.net/bitgoblin/blt/web/routes"
)

func RegisterRoutes(f *flamego.Flame) {
  // index routes
  f.Get("/", routes.GetDashboard)

  // project routes
  f.Group("/project", func() {
    f.Get("", func(c flamego.Context) {
		  c.Redirect("/project/list")
    })

    f.Get("/list", routes.ProjectGetList)

    f.Get("/create", routes.ProjectGetCreate)
    f.Post("/create", binding.Form(forms.ProjectForm{}), routes.ProjectPostCreate)
  })
}
